import bogoyaml;
import bogoyaml_static;

import std.stream;

void main() {
	{
		YamlHolder h = bogoyaml.yamlLoad("test_array.yml");
		alias bogoyaml_static.ToStatic!(char[][]) ToStaticStrs;
		char[][] c = ToStaticStrs.conv(h);
		assert("a" == c[0]);
		assert("c" == c[2]);
	}
	{
		YamlHolder h = bogoyaml.yamlLoad("test_static.yml");

		alias char[][][char[]] Cfg;
		alias bogoyaml_static.ToStatic!(Cfg) ToStaticCfg;
		Cfg cfg = ToStaticCfg.conv(h);

		assert("aaa" == cfg["hoge"][0]);
		assert("bbb" == cfg["hoge"][1]);
		assert("ccc" == cfg["hoge"][2]);
		assert("ddd" == cfg["fuga"][0]);
		assert("eee" == cfg["fuga"][1]);
		assert("fff" == cfg["gefu"][0]);
		assert("fff" == cfg["gefu"][1]);
		assert("fff" == cfg["gefu"][2]);
		assert("fff" == cfg["gefu"][3]);

		// reverse
		alias bogoyaml_static.FromStatic!(Cfg) FromStaticCfg;
		YamlHolder h2 = FromStaticCfg.conv(cfg);

		assert("aaa" == h2.get("hoge").get(0).str);
		assert("bbb" == h2.get("hoge").get(1).str);
		assert("ccc" == h2.get("hoge").get(2).str);
		assert("ddd" == h2.get("fuga").get(0).str);
		assert("eee" == h2.get("fuga").get(1).str);
		assert("fff" == h2.get("gefu").get(0).str);
		assert("fff" == h2.get("gefu").get(1).str);
		assert("fff" == h2.get("gefu").get(2).str);
		assert("fff" == h2.get("gefu").get(3).str);

		h2.dump("test_static.dump.yml");
	}

	{
		YamlHolder h = bogoyaml.yamlLoad("test_static.dump.yml");

		alias char[][][char[]] Cfg;
		alias bogoyaml_static.ToStatic!(Cfg) ToStaticCfg;
		Cfg cfg = ToStaticCfg.conv(h);

		assert("aaa" == cfg["hoge"][0]);
		assert("bbb" == cfg["hoge"][1]);
		assert("ccc" == cfg["hoge"][2]);
		assert("ddd" == cfg["fuga"][0]);
		assert("eee" == cfg["fuga"][1]);
		assert("fff" == cfg["gefu"][0]);
		assert("fff" == cfg["gefu"][1]);
		assert("fff" == cfg["gefu"][2]);
		assert("fff" == cfg["gefu"][3]);
	}
}

